﻿using Connected.Expressions.Collections;
using System.Collections.ObjectModel;

namespace Connected.Expressions;

public sealed class RowNumberExpression : DatabaseExpression
{
    public RowNumberExpression(IEnumerable<OrderExpression>? orderBy)
         : base(DatabaseExpressionType.RowCount, typeof(int))
    {
        OrderBy = orderBy is null ? new List<OrderExpression>().AsReadOnly() : orderBy.ToReadOnly();
    }

    public ReadOnlyCollection<OrderExpression> OrderBy { get; }
}