﻿using System.Collections.Immutable;
using Connected.Annotations;
using Connected.ServiceModel;

namespace Connected.Security.Membership;

[Service]
[ServiceUrl(SecurityRoutes.Membership)]
public interface IMembershipService
{
	[ServiceMethod(ServiceMethodVerbs.Get)]
	Task<ImmutableList<IMembership>?> Query();

	[ServiceMethod(ServiceMethodVerbs.Get | ServiceMethodVerbs.Post)]
	Task<ImmutableList<IMembership>?> Query(MembershipQueryArgs args);

	[ServiceMethod(ServiceMethodVerbs.Get | ServiceMethodVerbs.Post)]
	Task<IMembership?> Select(PrimaryKeyArgs<int> args);

	[ServiceMethod(ServiceMethodVerbs.Post)]
	Task<int> Insert(MembershipArgs args);

	[ServiceMethod(ServiceMethodVerbs.Post | ServiceMethodVerbs.Delete)]
	Task Delete(PrimaryKeyArgs<int> args);
}
